/* ************************************************** */
/* ****************** LISTS ************************* */
/* ************************************************** */

var ListPlatforms = Class.create( ListItem, {

    createItemDiv: function( itemHash, objectParameter )
    {
        return new Plateform( itemHash, objectParameter );
    }
} );

var ListParameters = Class.create( ListItem, {

    createItemDiv: function( itemHash, objectParameter )
    {
        return new Parameter( itemHash, objectParameter );
    },

    displayByCategory : function( parentNode, idIfNoItem, textIfNoItem, className )
    {
        parentNode.empty();
        if( 0 >= this.array.length )
            this.displayNoItem( parentNode, idIfNoItem, textIfNoItem );
        else
        {
            var categoryName;
            jQuery.each( this.array, jQuery.proxy( function( i, item )
            {
                if( categoryName != item.jsonElement[0].categoryName )
                {
                    var divCategory = $( document.createElement( "div" ) );
                    divCategory.html( item.jsonElement[0].categoryName );
                    parentNode.append( divCategory );
                    categoryName = item.jsonElement[0].categoryName;
                }
                if( className )
                    item.divItem.display( parentNode, className, true );
                else
                    item.divItem.display( parentNode, true );
            }, this ) );
        }
    }
} );


/* ***************************************************** */
/* ****************** ELEMENTS ************************* */
/* ***************************************************** */
var Plateform = Class.create( Item, {

    display : function( parentNode, className )
    {
        if( className )
            this.createContainer( "containerPlateform", "containerElement " + className );
        else
            this.createContainer( "containerPlateform", "containerElement" );
        this.addName( "plateform_name" );
        this.appendContainer( parentNode );
        this.addObservers();
    },

    select: function()
    {
        this.selectWithParameter( "plateform_selected" );
    },

    unselect: function()
    {
        this.unselectWithParameter( "plateform_selected" );
    }
} );

var Parameter = Class.create( Item, {

    display: function( parentNode, className, isArrowFirst )
    {
        if( className )
            this.createContainer( "containerParameter", "containerElement " + className );
        else
            this.createContainer( "containerParameter", "containerElement" );
        this.addNameWithMenus( "parameter_name", isArrowFirst );
        this.appendContainer( parentNode );
        this.addObservers();
    },

    select: function()
    {
        this.selectWithParameter( "parameter_selected" );
    },

    unselect: function()
    {
        this.unselectWithParameter( "parameter_selected" );
    }
} );
